package com.coforge.utils;

import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import javax.mail.Message;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.coforge.entities.QuizChallengeDetails;

public class SendEmail {

	private static final Logger LOG = LoggerFactory.getLogger(SendEmail.class);

	public List<QuizChallengeDetails> emailSend(List<QuizChallengeDetails> quizChallengeContestantDet, String category,
			final String user, final String password) {
		String host = "outlook.office365.com";

		// Get the session object
		Properties props = new Properties();
		props.put("mail.smtp.starttls.enable", "true");
		props.put("mail.smtp.host", host);
		props.put("mail.smtp.auth", "true");
		props.put("mail.smtp.port", "587");

		Session session = Session.getDefaultInstance(props, new javax.mail.Authenticator() {
			protected PasswordAuthentication getPasswordAuthentication() {
				return new PasswordAuthentication(user, password);
			}
		});

		QuizChallengeDetails challengeContestantDet = null;
		String challengeLink = "";
		MimeMessage message = null;
		List<QuizChallengeDetails> updQuizChallengeContestantDet = new ArrayList<QuizChallengeDetails>();

		// Compose the message
		for (int i = 0; i < quizChallengeContestantDet.size(); i++) {
			try {
				message = new MimeMessage(session);
				message.setFrom(new InternetAddress(user));
				message.setSubject("AutoGenerated: Quiz Challenge.");

				challengeContestantDet = quizChallengeContestantDet.get(i);
				challengeLink = "http://localhost:8080" + "/quiz/getQuestions?categoryCode=" + category
						+ "&page=0&challengeId=" + challengeContestantDet.getChallengeId() + "&contestantId="
						+ challengeContestantDet.getContestantId();
				message.setText(challengeLink);
				message.addRecipient(Message.RecipientType.TO,
						new InternetAddress(challengeContestantDet.getEmailId()));
				challengeContestantDet.setEmailSendStatus("Success");
				updQuizChallengeContestantDet.add(challengeContestantDet);
				// send the message
				Transport.send(message);
				LOG.info("Message sent successfully...");
			} catch (Exception e) {
				challengeContestantDet.setEmailSendStatus("Failed");
				updQuizChallengeContestantDet.add(challengeContestantDet);
				LOG.error("Unable to send the email...");
			}
		} // end for
		return updQuizChallengeContestantDet;
	}
}
